<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: ControlLaw.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_control_law_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ControlLaw.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_control_law_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef CONTROLLAW_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define CONTROLLAW_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_i_o_device_8h.html">IODevice.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>LayoutPosition;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">class </span>Matrix;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;}</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>filter {</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classflair_1_1filter_1_1_control_law.html">   36</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1filter_1_1_control_law.html">ControlLaw</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_i_o_device.html">core::IODevice</a> {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_control_law.html#abd6d4ee32a9e01a2d1b0513a0aadafcb">ControlLaw</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_object.html">core::Object</a> *parent, std::string name, uint32_t nb_out = 1);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_control_law.html#a62210ace4d3338cbc528ed712e72ac27">~ControlLaw</a>();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html#ace241d108bd0213135dbd6a5a561d0cf">Output</a>(uint32_t index = 0) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html#a3c42c9c7ae276e10d2ebad3a6701210d">UseDefaultPlot</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html#a228f8bf6857d96fa015bec9e016d2132">Update</a>(<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">core::Time</a> time);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classflair_1_1filter_1_1_control_law.html#a0892ecd37930c5d92a41449ab6fa1f10">   93</a></span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html#a0892ecd37930c5d92a41449ab6fa1f10">Reset</a>(){};</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  <a class="code" href="classflair_1_1core_1_1_matrix.html">core::Matrix</a> *<a class="code" href="classflair_1_1filter_1_1_control_law.html#ab88bfe866cc8f9794bda115d57139ab8">input</a>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classflair_1_1filter_1_1_control_law.html#ad0ec9102c1f3d5cea5e337ba02754f4b">  111</a></span>&#160;  <a class="code" href="classflair_1_1core_1_1_matrix.html">core::Matrix</a> *<a class="code" href="classflair_1_1filter_1_1_control_law.html#ad0ec9102c1f3d5cea5e337ba02754f4b">output</a>;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> UpdateFrom(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data) = 0;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;};</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;} <span class="comment">// end namespace filter</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="preprocessor">#endif // CONTROLLAW_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html">flair::filter::ControlLaw</a></div><div class="ttdoc">Base class for control law input must be created by reimplemented class. output is created by this cl...</div><div class="ttdef"><b>Definition:</b> ControlLaw.h:36</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_a228f8bf6857d96fa015bec9e016d2132"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#a228f8bf6857d96fa015bec9e016d2132">flair::filter::ControlLaw::Update</a></div><div class="ttdeci">void Update(core::Time time)</div><div class="ttdoc">Update using provided datas. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_object_html"><div class="ttname"><a href="classflair_1_1core_1_1_object.html">flair::core::Object</a></div><div class="ttdoc">Base class for all Framework&#39;s classes. </div><div class="ttdef"><b>Definition:</b> Object.h:83</div></div>
<div class="ttc" id="classflair_1_1core_1_1_i_o_device_html"><div class="ttname"><a href="classflair_1_1core_1_1_i_o_device.html">flair::core::IODevice</a></div><div class="ttdoc">Abstract class for input/ouput system. </div><div class="ttdef"><b>Definition:</b> IODevice.h:45</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_a62210ace4d3338cbc528ed712e72ac27"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#a62210ace4d3338cbc528ed712e72ac27">flair::filter::ControlLaw::~ControlLaw</a></div><div class="ttdeci">~ControlLaw()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_acc0fa041e08ecf73b2d1d723c339a736"><div class="ttname"><a href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">flair::core::Time</a></div><div class="ttdeci">unsigned long long Time</div><div class="ttdoc">Time definition, in ns. </div><div class="ttdef"><b>Definition:</b> Object.h:55</div></div>
<div class="ttc" id="_i_o_device_8h_html"><div class="ttname"><a href="_i_o_device_8h.html">IODevice.h</a></div><div class="ttdoc">Abstract class for input/ouput system. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_abd6d4ee32a9e01a2d1b0513a0aadafcb"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#abd6d4ee32a9e01a2d1b0513a0aadafcb">flair::filter::ControlLaw::ControlLaw</a></div><div class="ttdeci">ControlLaw(const core::Object *parent, std::string name, uint32_t nb_out=1)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_ab88bfe866cc8f9794bda115d57139ab8"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#ab88bfe866cc8f9794bda115d57139ab8">flair::filter::ControlLaw::input</a></div><div class="ttdeci">core::Matrix * input</div><div class="ttdoc">input matrix </div><div class="ttdef"><b>Definition:</b> ControlLaw.h:93</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_ad0ec9102c1f3d5cea5e337ba02754f4b"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#ad0ec9102c1f3d5cea5e337ba02754f4b">flair::filter::ControlLaw::output</a></div><div class="ttdeci">core::Matrix * output</div><div class="ttdoc">output matrix </div><div class="ttdef"><b>Definition:</b> ControlLaw.h:111</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_ace241d108bd0213135dbd6a5a561d0cf"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#ace241d108bd0213135dbd6a5a561d0cf">flair::filter::ControlLaw::Output</a></div><div class="ttdeci">float Output(uint32_t index=0) const </div><div class="ttdoc">Output value. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_a3c42c9c7ae276e10d2ebad3a6701210d"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#a3c42c9c7ae276e10d2ebad3a6701210d">flair::filter::ControlLaw::UseDefaultPlot</a></div><div class="ttdeci">virtual void UseDefaultPlot(const gui::LayoutPosition *position)</div><div class="ttdoc">Use default plot. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_layout_position_html"><div class="ttname"><a href="classflair_1_1gui_1_1_layout_position.html">flair::gui::LayoutPosition</a></div><div class="ttdoc">Class to define a position in a layout on the ground station. </div><div class="ttdef"><b>Definition:</b> LayoutPosition.h:28</div></div>
<div class="ttc" id="classflair_1_1core_1_1_matrix_html"><div class="ttname"><a href="classflair_1_1core_1_1_matrix.html">flair::core::Matrix</a></div><div class="ttdoc">Class defining a matrix. </div><div class="ttdef"><b>Definition:</b> Matrix.h:31</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html_a0892ecd37930c5d92a41449ab6fa1f10"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html#a0892ecd37930c5d92a41449ab6fa1f10">flair::filter::ControlLaw::Reset</a></div><div class="ttdeci">virtual void Reset()</div><div class="ttdoc">Reset the internal state of the control law. </div><div class="ttdef"><b>Definition:</b> ControlLaw.h:93</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_c640b400eb634d478af9606dd6c9f1e6.html">FlairFilter</a></li><li class="navelem"><a class="el" href="dir_9f4b49da50e680b0f2ceec11232e4cfd.html">src</a></li><li class="navelem"><a class="el" href="_control_law_8h.html">ControlLaw.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
